﻿assert( Postal, "Postal not found!")

------------------------------
--      Are you local?      --
------------------------------

local postallib = AceLibrary("PostalLib-1.0")
local L = AceLibrary("AceLocale-2.2"):new("Postal")

local toProcess = 0
local mailIndex = nil
local button = nil

local noop = function() end
local openAll = function() this.owner:OpenAll() end

----------------------------------
--      Module Declaration      --
----------------------------------

Postal_OpenAll = Postal:NewModule("OpenAll")
Postal_OpenAll.revision = tonumber(string.sub("$Revision: 26362 $", 12, -3))

function Postal_OpenAll:OnEnable()
	if not button then
		button = CreateFrame("Button", "PostalOpenAllButton", InboxFrame, "UIPanelButtonTemplate")
		button:SetWidth(120)
		button:SetHeight(25)
		button:SetPoint("CENTER", InboxFrame, "TOP", -15, -410)
		button:SetText(L["Open All"])
		button.owner = self
		button:SetScript("OnClick", openAll)
	end
	self:RegisterEvent("MAIL_CLOSED", "Reset")
end

function Postal_OpenAll:OpenAll()
	toProcess = GetInboxNumItems()
	if toProcess == 0 then return end

	button:SetScript("OnClick", noop)
	postallib:DisableInbox(1)

	self:RegisterEvent("Postal10_MailSkipped")
	self:RegisterEvent("Postal10_MailPurged", "ProcessNext")

	mailIndex = 1
	postallib:PurgeMail(mailIndex)
end

function Postal_OpenAll:Postal10_MailSkipped()
	mailIndex = mailIndex + 1
end

function Postal_OpenAll:ProcessNext()
	postallib:DisableInbox(1)
	toProcess = toProcess - 1
	if toProcess > 0 then
		postallib:PurgeMail(mailIndex)
	else
		self:Reset()
	end
end

function Postal_OpenAll:Reset()
	toProcess = 0

	postallib:DisableInbox(nil)
	if self:IsEventRegistered("Postal10_MailSkipped") then
		self:UnregisterEvent("Postal10_MailSkipped")
		self:UnregisterEvent("Postal10_MailPurged")
	end
	button:SetScript("OnClick", openAll)
	postallib:DisableInbox()

	InboxFrame_Update()
end

